#include <stdio.h>
#include <stdlib.h>
#include <check.h>

#include "hw1.h"


/** PUBLIC TESTS **/

START_TEST (test_second_min_simple)
{
    int test_min[3] = {2, 5, 8};
    ck_assert_int_eq(second_min(test_min, 3), 5);
}
END_TEST

START_TEST (test_second_min_longer)
{
    int test_min[10] = {100, 1, 13, 3, 7, 9, 11, 25, 4, 5};
    ck_assert_int_eq(second_min(test_min, 10), 3);
}
END_TEST

START_TEST (test_second_min_dups)
{
    int test_min[3] = {1, 1, -1};
    ck_assert_int_eq(second_min(test_min, 3), 1);
}
END_TEST

START_TEST (test_palindrome_empty)
{ ck_assert_int_eq(is_palindrome(""), true); }
END_TEST

START_TEST (test_palindrome_char)
{ ck_assert_int_eq(is_palindrome("x"), true); }
END_TEST

START_TEST (test_palindrome_2char)
{ ck_assert_int_eq(is_palindrome("aa"), true); }
END_TEST

START_TEST (test_palindrome_simple)
{ ck_assert_int_eq(is_palindrome("aba"), true); }
END_TEST

START_TEST (test_palindrome_word)
{ ck_assert_int_eq(is_palindrome("racecar"), true); }
END_TEST

START_TEST (test_not_palindrome_simple)
{ ck_assert_int_eq(is_palindrome("ab"), false); }
END_TEST

START_TEST (test_not_palindrome_space)
{ ck_assert_int_eq(is_palindrome("a ba"), false); }
END_TEST

START_TEST (test_not_palindrome_longer)
{ ck_assert_int_eq(is_palindrome("this is not a palindrome"), false); }
END_TEST

START_TEST (test_same_things)
{
    char str1[] = "This is a long sentence of some sort.";
    char str2[] = "This is not a long sentence of some sort";
    char dest[1024];
    same_things(str1, str2, dest);
    ck_assert_str_eq(dest, " a long sentence of some sort");
}
END_TEST

START_TEST (test_same_things_no_common)
{
    char str1[] = "asdf";
    char str2[] = "zxcv";
    char dest[1024];
    same_things(str1, str2, dest);
    ck_assert_str_eq(dest, "");
}
END_TEST

START_TEST (test_same_things_one_common)
{
    char str1[] = "asdfq";
    char str2[] = "qzxcv";
    char dest[1024];
    same_things(str1, str2, dest);
    ck_assert_str_eq(dest, "q");
}
END_TEST


/** GENERIC TEST SUITE CODE **/

Suite * test_suite(void)
{
    Suite *s;
    TCase *tc_core;
    s = suite_create("Default");
    tc_core = tcase_create("Core");

    tcase_add_test(tc_core, test_second_min_simple);
    tcase_add_test(tc_core, test_second_min_longer);
    tcase_add_test(tc_core, test_second_min_dups);

    tcase_add_test(tc_core, test_palindrome_empty);
    tcase_add_test(tc_core, test_palindrome_char);
    tcase_add_test(tc_core, test_palindrome_2char);
    tcase_add_test(tc_core, test_palindrome_simple);
    tcase_add_test(tc_core, test_palindrome_word);
    tcase_add_test(tc_core, test_not_palindrome_simple);
    tcase_add_test(tc_core, test_not_palindrome_space);
    tcase_add_test(tc_core, test_not_palindrome_longer);

    tcase_add_test(tc_core, test_same_things);
    tcase_add_test(tc_core, test_same_things_no_common);
    tcase_add_test(tc_core, test_same_things_one_common);

    suite_add_tcase(s, tc_core);
    return s;
}

int run_testsuite()
{
    int number_failed;
    Suite *s;
    SRunner *sr;

    s = test_suite();
    sr = srunner_create(s);

    srunner_run_all(sr, CK_NORMAL);
    number_failed = srunner_ntests_failed(sr);
    srunner_free(sr);

    if (number_failed == 0) {
        printf("SUCCESS: All current tests passed!\n");
    } else {
        printf("FAILURE: At least one test failed or crashed.\n");
    }

    return (number_failed == 0) ? EXIT_SUCCESS : EXIT_FAILURE;
}

int main(int argc, char* argv[])
{
    return run_testsuite();
}

